# Getting help

Here is a helpful list of "where to get help" depending on the topic:

-   **How to use CodableCSV?**

    The first place to look is the [README file](https://github.com/dehesa/CodableCSV/blob/master/README.md). It is kept updated and there is a wealth of information under each right-pointing [caret](https://en.wikipedia.org/wiki/Caret). Information spans from basic usage to tips on how to squeeze the best performance.

    You can also look for issues labeled as [question](https://github.com/dehesa/CodableCSV/issues?q=is%3Aissue+label%3Aquestion+). Odds are your question has been asked before.

    If the information is not there, feel free to create a [new issue](https://github.com/dehesa/CodableCSV/issues/new) labeling it as _question_.

-   **How to use Swift's [Codable](https://developer.apple.com/documentation/swift/codable) interface?**

    There are many places to learn how to use Codable.

    -   [Apple's Article](https://developer.apple.com/documentation/foundation/archives_and_serialization/encoding_and_decoding_custom_types) on encoding and decoding custom types.
    -   The [Guide to Swift Codable](https://flight.school/books/codable) from [Mattt](https://twitter.com/mattt)'s [Flight School](https://flight.school).
    -   CodableCSV's [README](https://github.com/dehesa/CodableCSV/blob/master/README.md) also includes some usage examples.

    For complex queries, go to the [Swift forums](https://forums.swift.org), specifically the [_Using Swift_](https://forums.swift.org/c/swift-users/15) category, setting the search tag to [_codable_](https://forums.swift.org/tags/c/swift-users/15/codable).

-   **How to contribute to CodableCSV?**

    This project uses the standard [CONTRIBUTING.md](CONTRIBUTING.md) file explaining the contribution guidelines. This same file also has a section on "where to start contributing", in case you want to contribute but you are unsure where to start.

    Also take a look at the Github's [projects page](https://github.com/dehesa/CodableCSV/projects) where you can see the project's Kanban board, or at a higher level, take a look at the [Roadmap graph](Assets/Roadmap.svg).

-   **What is the Comma-separated values format?**

    At a high-level, the wikipedia page on [CSV](https://en.wikipedia.org/wiki/Comma-separated_values) is a great starting point.

    The CSV file format is not fully standardized, the closest there is to a standard is the [RFC4180](https://www.ietf.org/rfc/rfc4180.txt).

-   **Problems with Github**.

    Check their [fantastic documentation](https://help.github.com/en), go to [Github's learning lab](https://lab.github.com), or ask [Github support](https://support.github.com).
